library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use WORK.cpu_defs.all;

entity IR is
	port(clk, rst : in std_logic;
		  Addr_bus, IR_load : in std_logic;
		  op : out opcode;
		  sysbus : inout std_logic_vector(word_w-1 downto 0));
end IR;

architecture rtl of IR is
	signal instr_reg : std_logic_vector(word_w-1 downto 0);
begin
	sysbus <= rfill & instr_reg(word_w-op_w-1 downto 0) 
					when Addr_bus = '1' else (others => 'Z');
	op <= slv2op(instr_reg(word_w-1 downto word_w-op_w));
	
	process (clk, rst) is
	begin
		if rst = '0' then
			instr_reg <= (others => '0');
		elsif rising_edge(clk) then
			if IR_load = '1' then
				instr_reg <= sysbus;
			end if;
		end if;
	end process;
end rtl;

