library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use WORK.cpu_defs.all;

entity OUTPUT is
	port(clk, rst, OUTPUT_load : in std_logic;
		  sysbus : in std_logic_vector(word_w-1 downto 0);
		  led : out std_logic_vector(7 downto 0));
end OUTPUT;

architecture Behavioral of OUTPUT is
	signal value : std_logic_vector(word_w-1 downto 0) := (others => '0');
begin
	
	process (clk, rst) is 
	begin
		if rst = '0' then
			value <= (others => '0');
		elsif rising_edge(clk) then
			if OUTPUT_load = '1' then
				value <= sysbus;
			end if;
		end if;
	end process;
	
	led <= value;
end architecture;