library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;
use WORK.cpu_defs.all;

entity PC is 
	port(clk, rst : in std_logic;
		  PC_bus, PC_load, PC_inc : in std_logic;
		  sysbus : inout std_logic_vector(word_w-1 downto 0));
end PC;

architecture rtl of PC is
	signal count : unsigned(word_w - op_w - 1 downto 0);
begin
	sysbus <= rfill & std_logic_vector(count)
					when PC_bus = '1' else (others => 'Z');
	
	process (clk, rst) is
	begin
		if rst = '0' then
			count <= (others => '0');
		elsif rising_edge(clk) then
			if PC_load = '1' then
				if PC_inc = '1' then
					count <= count + 1;
				else
					count <= unsigned(sysbus(word_w - op_w - 1 downto 0));
				end if;
			end if;
		end if;
	end process;

end rtl;

